/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1

import (
	v1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis/kumori/v1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KukuLinkLister helps list KukuLinks.
type KukuLinkLister interface {
	// List lists all KukuLinks in the indexer.
	List(selector labels.Selector) (ret []*v1.KukuLink, err error)
	// KukuLinks returns an object that can list and get KukuLinks.
	KukuLinks(namespace string) KukuLinkNamespaceLister
	KukuLinkListerExpansion
}

// kukuLinkLister implements the KukuLinkLister interface.
type kukuLinkLister struct {
	indexer cache.Indexer
}

// NewKukuLinkLister returns a new KukuLinkLister.
func NewKukuLinkLister(indexer cache.Indexer) KukuLinkLister {
	return &kukuLinkLister{indexer: indexer}
}

// List lists all KukuLinks in the indexer.
func (s *kukuLinkLister) List(selector labels.Selector) (ret []*v1.KukuLink, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuLink))
	})
	return ret, err
}

// KukuLinks returns an object that can list and get KukuLinks.
func (s *kukuLinkLister) KukuLinks(namespace string) KukuLinkNamespaceLister {
	return kukuLinkNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KukuLinkNamespaceLister helps list and get KukuLinks.
type KukuLinkNamespaceLister interface {
	// List lists all KukuLinks in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1.KukuLink, err error)
	// Get retrieves the KukuLink from the indexer for a given namespace and name.
	Get(name string) (*v1.KukuLink, error)
	KukuLinkNamespaceListerExpansion
}

// kukuLinkNamespaceLister implements the KukuLinkNamespaceLister
// interface.
type kukuLinkNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KukuLinks in the indexer for a given namespace.
func (s kukuLinkNamespaceLister) List(selector labels.Selector) (ret []*v1.KukuLink, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1.KukuLink))
	})
	return ret, err
}

// Get retrieves the KukuLink from the indexer for a given namespace and name.
func (s kukuLinkNamespaceLister) Get(name string) (*v1.KukuLink, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1.Resource("kukulink"), name)
	}
	return obj.(*v1.KukuLink), nil
}
